package org.bitbucket.openisoj;

public class Utils {
	public static int getRequestMsgType(int msgType) {
		return msgType & 0xffef;
	}

	public static String maskPan(String pan) {
		if (pan == null)
			return null;

		final int frontLength = 6;
		final int endLength = 4;
		final int unmaskedLength = frontLength + endLength;

		int totalLength = pan.length();

		if (totalLength <= unmaskedLength)
			return pan;

		StringBuilder sb = new StringBuilder(totalLength);
		sb.append(pan.substring(0, frontLength));
		sb.append(Utils.padLeft("", totalLength - unmaskedLength, '*'));
		sb.append(pan.substring((totalLength - endLength), totalLength));
		return sb.toString();
	}

	public static int msgTypeToInt(String msgType) {
		return Integer.parseInt(msgType, 16);
	}

	public static String msgTypeToString(int msgType) {
		return padLeft(Integer.toHexString(msgType), 4, '0');
	}

	public static String padLeft(String data, int length, char padChar) {

		int remaining = length - data.length();

		String newData = data;
		for (int i = 0; i < remaining; i++)
			newData = padChar + newData;
		return newData;
	}

	public static String padRight(String data, int length, char padChar) {

		int remaining = length - data.length();

		String newData = data;

		for (int i = 0; i < remaining; i++)
			newData = newData + padChar;

		return newData;
	}

	public static boolean isNullOrEmpty(String data) {
		if (data == null)
			return true;
		if (data.length() == 0)
			return true;

		return false;
	}

	public static boolean isNullOrWhitespace(String data) {
		if (isNullOrEmpty(data))
			return true;
		if (data.trim().length() == 0)
			return true;
		return false;
	}
}
